package com.ruoyi.sy.service;

import com.ruoyi.common.core.domain.entity.SysUser;
import com.ruoyi.common.enums.ExamType;
import com.ruoyi.sy.domain.SyMajor;
import org.apache.ibatis.annotations.Param;

import java.util.List;

/**
 * 专业Service接口
 *
 * @author mingxue
 * @date 2022-04-27
 */
public interface ISyMajorService
{
    /**
     * 查询专业
     *
     * @param id 专业ID
     * @return 专业
     */
    public SyMajor selectSyMajorById(Long id);
    public SyMajor selectSyMajorByCode(String code);
    public List<SyMajor> selectSyMajorByLevel(String examType, Integer level);

    /**
     * 查询专业列表
     *
     * @param syMajor 专业
     * @return 专业集合
     */
    public List<SyMajor> selectSyMajorList(SyMajor syMajor);
    public List<SyMajor> selectSyMajorAndChildrenByCode(SyMajor syMajor);

    /**
     * 新增专业
     *
     * @param syMajor 专业
     * @return 结果
     */
    public int insertSyMajor(SyMajor syMajor);

    /**
     * 修改专业
     *
     * @param syMajor 专业
     * @return 结果
     */
    public int updateSyMajor(SyMajor syMajor);

    /**
     * 批量删除专业
     *
     * @param ids 需要删除的专业ID
     * @return 结果
     */
    public int deleteSyMajorByIds(Long[] ids);

    /**
     * 删除专业信息
     *
     * @param id 专业ID
     * @return 结果
     */
    public int deleteSyMajorById(Long id);


    List<SyMajor> selectPlanMajorList(Integer planYear, SysUser user, Long universityId);

    public List<SyMajor> selectMajorsByPlan(String location);

}
